# -*- coding:Utf-8 -*-
# quick_menu V1.246p (02/01/2009) by DoCky


import psyco, os.path, re, es, langlib, playerlib, popuplib, gamethread, repeat
psyco.full()


qm_info = es.AddonInfo()
qm_info.author = "DoCky"
qm_info.name = "quick_menu"
qm_info.version = "1.246p"
qm_info.url = "http://addons.eventscripts.com/addons/user/11751"

qm_lang = langlib.Strings(es.getAddonPath("quick_menu") + "/language.ini")
qm_path = es.ServerVar("eventscripts_gamedir")
qm_vers = es.ServerVar(qm_info.name, "", "By DoCky -")
qm_vers.set(qm_info.version)
qm_vers.makepublic()

if "cstrike" in str(qm_path):
    qm_game = "css"
    qm_tags = ("[SPEC]", "[T]", "[CT]")
    qm_cate = (
        ("gun", ("glock", "usp", "p228", "deagle", "fiveseven", "elite")),
        ("pmp", ("m3", "xm1014")),
        ("pms", ("tmp", "mac10", "mp5navy", "ump45", "p90")),
        ("rif", ("galil", "famas", "ak47", "m4a1", "sg552", "aug", "m249")),
        ("snp", ("scout", "awp", "g3sg1", "sg550")),
        ("gre", ("flashbang", "hegrenade", "smokegrenade")),
        ("eqm", ("vest", "vesthelm", "defuser", "nvgs", "c4")))
    qm_arms = {
        "glock" : [0, 400], "usp" : [0, 500], "p228" : [0, 600], "deagle" : [0, 650], "fiveseven" : [0, 750], "elite" : [0, 800],
        "m3" : [0, 1700], "xm1014" : [0, 3000],
        "tmp" : [0, 1250], "mac10" : [0, 1400], "mp5navy" : [0, 1500], "ump45" : [0, 1700], "p90" : [0, 2350],
        "galil" : [0, 2000], "famas" : [0, 2250], "ak47" : [0, 2500], "m4a1" : [0, 3100], "sg552" : [0, 3500], "aug" : [0, 3500], "m249" : [0, 5750],
        "scout" : [0, 2750], "awp" : [0, 4750], "g3sg1" : [0, 4200], "sg550" : [0, 5000],
        "flashbang" : [0, 200], "hegrenade" : [0, 300], "smokegrenade" : [0, 300],
        "vest" : [0, 650], "vesthelm" : [0, 1000], "defuser" : [0, 200], "nvgs" : [0, 1250], "c4" : [0, 0]}

else:
    qm_game = "dod"
    qm_tags = ("[SPEC]", "[Allies]", "[Axis]")
    qm_cate = (
        ("fus", ("garand", "riflegren_us", "k98", "riflegren_ger")),
        ("ast", ("thompson", "mp40")),
        ("sup", ("bar", "mp44")),
        ("spr", ("spring", "k98_scoped")),
        ("mit", ("30cal", "mg42")),
        ("roq", ("bazooka", "m1carabine", "pschreck", "c96")),
        ("sec", ("colt", "p38")),
        ("exp", ("frag_us", "smoke_us", "frag_ger", "smoke_ger")))
    qm_arms = {
        "garand" : 0, "riflegren_us" : 0, "k98" : 0, "riflegren_ger" : 0,
        "thompson" : 0, "mp40" : 0,
        "bar" : 0, "mp44" : 0,
        "spring" : 0, "k98_scoped" : 0,
        "30cal" : 0, "mg42" : 0,
        "bazooka" : 0, "m1carabine" : 0, "pschreck" : 0, "c96" : 0,
        "colt" : 0, "p38" : 0,
        "frag_us" : 0, "smoke_us" : 0, "frag_ger" : 0, "smoke_ger" : 0}








class File:
    """
        Reader of text file (ex: '.cfg', '.txt', ...)
            * elimination of comments

                - basic
            syntax: File().read(<filepath>)
            return: ["line1", "line2", ect...]
            exemple: File.read(es.getAddonPath("myName") + "config.txt")

                - with separator
            syntax: File().read(<filepath>, <separator>)
            return: [("arg1", "val1"), ("arg2", "val2"), ect...]
            exemple: File.read(es.getAddonPath("myName") + "config.txt", "=")
    """

    def __init__(self):
        self._line = []

    def __loop(self, i, s):
        while i < len(self._line):
            self._line[i] = re.sub('//.*|^(( |\t)+)|(( |\t)+)$|(\r)+|(\t)+|(\n)+|(")+|', "", self._line[i])
            if not self._line[i]: del(self._line[i])
            else:

                if s:
                    sepa = self._line[i].split(s)
                    if len(sepa) > 1:
                        self._line[i] = (sepa[0].strip(), sepa[1].strip())
                        i += 1
                    else: del(self._line[i])
                else: i += 1

    def read(self, pathern = "", separator = ""):
        self._line = []
        if not pathern:
            es.dbgmsg(0, "[quick_menu] syntax : File().read(<file pathern> [separator])")
            return self._line[:]

        else:
            try:
                line = open(pathern, "r")
                self._line = line.readlines()
                line.close(), self.__loop(0, separator)
            except:
                self._line = []
                es.dbgmsg(0, "[quick_menu] Cannot read file : %s" % pathern)
            finally: return self._line[:]



class Menu:
    """
        Quick admin menu
    """

    def __init__(self):
        """
            Initialisation and creation of menu fonctionality
        """

        self._name = set()
        self._name.add("qm_recept")
        self._name.add("qm_action")
        self._name.add("qm_action_swap")
        self._name.add("qm_action_kick")
        self._name.add("qm_action_kick")
        self._name.add("qm_action_remo")
        self._name.add("qm_levels")
        self._name.add("qm_restri")
        self._band, self._maps = {}, {}

        self.m_intern = Menu.Intern()
        self.m_action = Menu.Action()
        self.m_levels = Menu.Levels()
        self.m_execmd = Menu.Execmd()
        self.m_restri = Menu.Restri()

        m = popuplib.create("qm_recept")
        m.addline(self.lang("menu recept title"))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu recept player", 1))
        m.addline(self.lang("menu recept levels", 2))
        m.addline(self.lang("menu recept execmd", 3))
        m.addline(self.lang("menu recept restri", 4))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu exit", 0, False))
        m.menuselect = self.__recept

        m = popuplib.create("qm_action")
        m.addline(self.lang("menu action title"))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu action swap", 1))
        m.addline(self.lang("menu action slay", 2))
        m.addline(self.lang("menu action kick", 3))
        m.addline(self.lang("menu action ban", 4))
        m.addline(self.lang("menu action unban", 5))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu back", 9, False))
        m.addline(self.lang("menu exit", 0, False))
        m.submenu(9, "qm_recept")
        m.menuselect = self.__action

        m = popuplib.create("qm_levels")
        m.addline(self.lang("menu levels title"))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu levels now", 1))
        m.addline(self.lang("menu levels next", 2))
        m.addline(self.lang("menu levels time", 3))
        m.addline(self.lang("menu levels recache", 4))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu back", 9, False))
        m.addline(self.lang("menu exit", 0, False))
        m.submenu(4, "qm_levels")
        m.submenu(9, "qm_recept")
        m.menuselect = self.__levels

        m = popuplib.create("qm_restri")
        m.addline(self.lang("menu restri title"))
        m.addline(self.lang("menu spac"))
        if qm_game == "css":
            m.addline(self.lang("menu restri gun", 1))
            m.addline(self.lang("menu restri pmp", 2))
            m.addline(self.lang("menu restri pms", 3))
            m.addline(self.lang("menu restri rif", 4))
            m.addline(self.lang("menu restri snp", 5))
            m.addline(self.lang("menu restri gre", 6))
            m.addline(self.lang("menu restri eqm", 7))
        elif qm_game == "dod":
            m.addline(self.lang("menu restri fus", 1))
            m.addline(self.lang("menu restri ast", 2))
            m.addline(self.lang("menu restri sup", 3))
            m.addline(self.lang("menu restri spr", 4))
            m.addline(self.lang("menu restri mit", 5))
            m.addline(self.lang("menu restri roq", 6))
            m.addline(self.lang("menu restri sec", 7))
            m.addline(self.lang("menu restri exp", 8))
        m.addline(self.lang("menu spac"))
        m.addline(self.lang("menu back", 9, False))
        m.addline(self.lang("menu exit", 0, False))
        m.submenu(9, "qm_recept")
        m.menuselect = self.__restri

    def __recept(self, i, c, n):
        if c == 1: popuplib.send("qm_action", i)
        elif c == 2: popuplib.send("qm_levels", i)
        elif c == 3: self.m_intern.i_list.menu("cmnd", i, qm_lang("menu execmd title", lang = playerlib.getPlayer(i).get("lang")), _cmnd)
        elif c == 4: popuplib.send("qm_restri", i)

    def __action(self, i, c, n):
        if c == 1: self.m_intern.i_list.menu("swap", i, qm_lang("menu action swap", lang = playerlib.getPlayer(i).get("lang")))
        elif c == 2: self.m_intern.i_list.menu("slay", i,
                                               qm_lang("menu action slay", lang = playerlib.getPlayer(i).get("lang")),
                                               [u for u in es.getUseridList() if not es.getplayerprop(u, "CBasePlayer.pl.deadflag")])
        elif c == 3: self.m_intern.i_list.menu("kick", i, qm_lang("menu action kick", lang = playerlib.getPlayer(i).get("lang")))
        elif c == 4: self.m_intern.i_list.menu("bans", i, qm_lang("menu action ban", lang = playerlib.getPlayer(i).get("lang")))
        elif c == 5: self.m_intern.i_list.menu("remo", i, qm_lang("menu action unban", lang = playerlib.getPlayer(i).get("lang")))

    def __levels(self, i, c, n):
        if c < 4:
            self._maps[i] = c
            self.m_intern.i_list.menu("maps", i, qm_lang("menu levels title", lang = playerlib.getPlayer(i).get("lang")), _maps)
        elif c == 4:
            global _maps
            _maps = [os.path.splitext(n)[0] for n in os.listdir("%s/maps/" % qm_path) if os.path.splitext(n)[1] == ".bsp"]
            es.tell(i, "#multi", qm_lang("map list actualised", lang = playerlib.getPlayer(i).get("lang")))

    def __restri(self, i, c, n):
        if qm_game == "css" and c < 8:
            self.m_intern.i_list.menu("rest", i,
                                      qm_lang("menu restri %s title" % qm_cate[c - 1][0], lang = playerlib.getPlayer(i).get("lang")),
                                      qm_cate[c - 1][1])
        if qm_game == "dod" and c < 9:
            self.m_intern.i_list.menu("rest", i,
                                      qm_lang("menu restri %s title" % qm_cate[c - 1][0], lang = playerlib.getPlayer(i).get("lang")),
                                      qm_cate[c - 1][1])

    def lang(self, n, i = None, s = 1, f = {}):
        if not qm_lang.has_key(n): es.dbgmsg(0, "[quick_menu] Can't find [%s] in language file : ../addons/eventscripts/quick_menu/language.ini" % n)
        else:
            line = {}
            for langue, string in qm_lang[n].items():
                if len(f): string = qm_lang(n, opts = f, lang = langue)
                if i == None: line[langue] = string
                else:
                    if not s: line[langue] = "%s. %s" % (i, string)
                    else: line[langue] = "->%s. %s" % (i, string)
            return line



    class Intern:
        """
            Create a timer when player is banned
            Create a menu with an entity list
            Get players arguments by chat
                * kick
                * ban
                * unban
        """

        def __init__(self):
            self.i_time = Menu.Intern.Time()
            self.i_list = Menu.Intern.List()
            self.i_hook = Menu.Intern.Hook()


        class Time:
            """
                Create a timer when player is banned
                    return time format: hh:mm:ss
            """

            def __loop(self):
                """ """

            def init(self, n):
                repeat.create(n, self.__loop)

            def nume(self, n):
                time = repeat.find(n)["remaining"]
                seco = time % 60
                minu = time / 60
                hour = minu / 60
                if seco < 10: seco = "0%s" % seco
                if minu < 10: minu = "0%s" % minu
                if hour < 10: hour = "0%s" % hour
                return "%s:%s:%s" % (hour, minu, seco)


        class List:
            """
                Create a menu with an entity list
            """

            def __init__(self):
                self._list = {}

            def __page(self, n, m):
                if n < 2:page = 1
                else:
                    page = n / m
                    if n % m > 1:page += 1
                return page

            def __item(self, p, t, n, m):
                if p < t:item = m
                else:item = n - (p - 1) * m
                return item

            def menu(self, f, i, t, l = es.getUseridList()):
                if not es.exists("userid", i): es.dbgmsg(0, "[quick_menu] Cannot find userid : %s" % i)
                else:
                    if f == "remo":
                        es.server.cmd("writeid")
                        perm = map(lambda x: x.strip().split(" ")[2], File().read("%s/cfg/banned_user.cfg" % qm_path))
                        l = perm + _menu._band.keys()

                    numb = len(l)
                    page, indp = self.__page(numb, 7), 0
                    lang = playerlib.getPlayer(i).get("lang")

                    while indp < page:
                        indp += 1
                        name, item, indi = "qm_%s_%s_%s" % (f, i, indp), self.__item(indp, page, numb, 7), 0
                        _menu._name.add(name)
                        self._list[name] = {}
                        m = popuplib.create(name)
                        if f == "rest": m.addline(t)
                        else: m.addline("%s     %s/%s" % (t, indp, page))

                        m.addline(" ")

                        if f == "slay" and numb == 0: m.addline(qm_lang("menu action slay emptie", lang = playerlib.getPlayer(i).get("lang")))
                        if f == "remo" and numb == 0: m.addline(qm_lang("menu action unban emptie", lang = playerlib.getPlayer(i).get("lang")))
                        if f == "cmnd" and numb == 0: m.addline(qm_lang("menu execmd emptie", lang = playerlib.getPlayer(i).get("lang")))

                        while indi < item:
                            indo = (indp - 1) * 7 + indi
                            indi += 1

                            if f == "swap":
                                user = es.getplayername(l[indo])
                                team = es.getplayerteam(l[indo])
                                self._list[name][indi] = (l[indo], team, user)

                                if team == 2: m.addline("->%s. %s %s" % (indi, qm_tags[1], user))
                                elif team == 3: m.addline("->%s. %s %s" % (indi, qm_tags[2], user))
                                else: m.addline("->%s. %s %s" % (indi, qm_tags[0], user))

                            elif f == "slay":
                                user = es.getplayername(l[indo])
                                self._list[name][indi] = (l[indo], user)
                                m.addline("->%s. %s" % (indi, user))

                            elif f == "kick":
                                user = es.getplayername(l[indo])
                                self._list[name][indi] = (l[indo], user)
                                m.addline("->%s. %s" % (indi, user))

                            elif f == "bans":
                                user = es.getplayername(l[indo])
                                unid = es.getplayersteamid(l[indo])
                                self._list[name][indi] = (l[indo], unid, user)
                                m.addline("->%s. %s" % (indi, user))

                            elif f == "remo":
                                if l[indo] in perm:
                                    usid = es.getuserid(l[indo])
                                    user = es.getplayername(usid)
                                    self._list[name][indi] = (usid, l[indo], user)
                                    if usid: m.addline("->%s. [B] %s" % (indi, es.getplayername(usid)))
                                    else: m.addline("->%s. [B] %s" % (indi, l[indo]))

                                elif l[indo] in _menu._band:
                                    usid = es.getuserid(l[indo])
                                    user = es.getplayername(usid)
                                    self._list[name][indi] = (usid, l[indo], user)
                                    if usid: m.addline("->%s. [%s] %s" % (indi, _menu.m_intern.i_time.nume("qm_%s" % l[indo]), user))
                                    else: m.addline("->%s. [%s] %s" % (indi, _menu.m_intern.i_time.nume("qm_%s" % l[indo]), _menu._band[l[indo]]))

                            elif f == "maps":
                                self._list[name][indi] = l[indo]
                                m.addline("->%s. %s" % (indi, l[indo]))

                            elif f == "cmnd":
                                self._list[name][indi] = l[indo]
                                m.addline("->%s. %s" % (indi, l[indo][0]))

                            elif f == "rest":
                                self._list[name][indi] = (l[indo], qm_lang("menu restri %s" % l[indo], lang = playerlib.getPlayer(i).get("lang")))
                                if qm_game == "css": rest = qm_arms[l[indo]][0]
                                elif qm_game == "dod": rest = qm_arms[l[indo]]
                                if not rest: m.addline("->%s. %s" % (indi, self._list[name][indi][1]))
                                else: m.addline("->%s. * %s" % (indi, self._list[name][indi][1]))

                        m.addline(" ")

                        if indp < page:
                            m.addline("8. %s" % qm_lang("menu next", lang = lang))
                            m.submenu(8, "qm_%s_%s_%s" % (f, i, indp + 1))
                        if indp == 1:
                            m.addline("9. %s" % qm_lang("menu back", lang = lang))
                            if f == "maps": m.submenu(9, "qm_levels")
                            elif f == "cmnd": m.submenu(9, "qm_recept")
                            elif f == "rest": m.submenu(9, "qm_restri")
                            else: m.submenu(9, "qm_action")
                        else:
                            m.addline("9. %s" % qm_lang("menu back", lang = lang))
                            m.submenu(9, "qm_%s_%s_%s" % (f, i, indp - 1))

                        if f == "swap": m.menuselect = _menu.m_action.a_swap.swap
                        elif f == "slay": m.menuselect = _menu.m_action.a_slay.slay
                        elif f == "kick": m.menuselect = _menu.m_action.a_kick.kick
                        elif f == "bans": m.menuselect = _menu.m_action.a_bans.bans
                        elif f == "remo":
                            m.menuselect = _menu.m_action.a_remo.remo
                            _menu.m_intern.i_hook._hook[i] = "remo"
                            _menu.m_intern.i_hook.chat()
                            es.tell(i, "#multi", qm_lang("write unban by chat", lang = lang))
                        elif f == "maps": m.menuselect = _menu.m_levels.maps

                        elif f == "cmnd":
                            m.menuselect = _menu.m_execmd.cmnd
                            _menu.m_intern.i_hook._hook[i] = "cmnd"
                            _menu.m_intern.i_hook.chat()
                            es.tell(i, "#multi", qm_lang("write cmd by chat", lang = lang))

                        elif f == "rest": m.menuselect = _menu.m_restri.rest
                        m.addline("0. %s" % qm_lang("menu exit", lang = lang))
                    popuplib.send("qm_%s_%s_1" % (f, i), i)


        class Hook:
            """
                Get players arguments by chat
                    * kick
                    * ban
                    * unban
                    * rcon
            """

            def __init__(self):
                self._hook = {}

            def __kick(self, i, t):
                if not es.exists("userid", self._hook[i][1][0]): es.tell(i, "#multi", qm_lang("userid not exist", opts = {"userid" : self._hook[i][1][0]}, lang = playerlib.getPlayer(i).get("lang")))
                else:
                    es.server.queuecmd("kickid %s %s" % (self._hook[i][1][0], t))
                    del(self._hook[i])
                    self.chat()
                    if popuplib.isqueued("qm_action_kick", i): popuplib.unsendname("qm_action_kick", i)
                    gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("kick", i, qm_lang("menu action kick", lang = playerlib.getPlayer(i).get("lang"))))

            def __bans(self, i, t):
                text = t.split(" ")
                time = text[0]
                del(text[0])

                if not time.isdigit(): es.tell(i, "#multi", qm_lang("cmd syntax ban", lang = playerlib.getPlayer(i).get("lang")))
                else:
                    es.server.queuecmd("banid %s %s;kickid %s %s;writeid" % (time, self._hook[i][1][0], self._hook[i][1][0], " ".join(text)))
                    if int(time):
                        name = "qm_%s" % self._hook[i][1][1]
                        _menu._band[self._hook[i][1][1]] = self._hook[i][1][2]
                        _menu.m_intern.i_time.init(name)
                        repeat.start(name, 1, float(time) * 60)

                    del(self._hook[i])
                    self.chat()
                    if popuplib.isqueued("qm_action_bans", i): popuplib.unsendname("qm_action_bans", i)
                    gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("bans", i, qm_lang("menu action ban", lang = playerlib.getPlayer(i).get("lang"))))

            def __remo(self, i, t):
                unid = t.split(" ")[0].upper()
                if not "STEAM_" in unid: es.tell(i, "#multi", qm_lang("cmd syntax unban", lang = playerlib.getPlayer(i).get("lang")))
                else:
                    es.server.queuecmd("removeid %s;writeid" % unid)
                    if unid in _menu._band: del(_menu._band[unid])
                    del(self._hook[i])
                    self.chat()
            
                    name = popuplib.active(i)["name"]
                    if name != "0": popuplib.unsendname(name, i)
                    gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("remo", i, qm_lang("menu action unban", lang = playerlib.getPlayer(i).get("lang"))))

            def __cmnd(self, i, t):
                es.server.queuecmd(t)
                es.tell(i, "#multi", qm_lang("cmd executed", opts = {"command" : t}, lang = playerlib.getPlayer(i).get("lang")))

            def __hook(self, i, t, o):
                if self._hook.has_key(i):
                    text = list(t.strip())
                    del(text[0])
                    del(text[len(text) - 1])
                    text = "".join(text)

                    if self._hook[i][0] == "kick": self.__kick(i, text)
                    elif self._hook[i][0] == "bans": self.__bans(i, text)
                    elif self._hook[i] == "remo": self.__remo(i, text)
                    elif self._hook[i] == "cmnd": self.__cmnd(i, text)
                    i = 0
                return i, t, o

            def chat(self):
                if len(self._hook) and not self.__hook in es.addons.SayListeners:
                    es.addons.registerSayFilter(self.__hook)
                    es.dbgmsg(0, "[quick_menu] Chat is now hooked")
                else: self.stop()

            def stop(self):
                if self.__hook in es.addons.SayListeners:
                    es.addons.unregisterSayFilter(self.__hook)
                    es.dbgmsg(0, "[quick_menu] Chat is now unhooked")



    class Action:
        """
            Action :
                * swap
                * kick
                * ban
                * unban
        """

        def __init__(self):
            self.a_swap = Menu.Action.Swap()
            self.a_slay = Menu.Action.Slay()
            self.a_kick = Menu.Action.Kick()
            self.a_bans = Menu.Action.Bans()
            self.a_remo = Menu.Action.Remo()


        class Swap:
            """
                Action swap
            """

            def __init__(self):
                m = popuplib.create("qm_action_swap")
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.submenu(9, "qm_action")
                m.menuselect = self.__swap
                self._swap = {}

            def __swap(self, i, c, n):
                if c < 3:
                    if not es.exists("userid", self._swap[i][0]): es.tell(i, "#multi", qm_lang("userid not exist", opts = {"userid" : self._swap[i][0]}, lang = playerlib.getPlayer(i).get("lang")))
                    else:
                        user = self._swap[i][0]
                        swap = self._swap[i][c]
                        team = es.getplayerteam(user)

                        if team == swap: es.tell(i, "#multi", qm_lang("cmd swap", opts = {"player" : self._swap[i][3]}, lang = playerlib.getPlayer(i).get("lang")))
                        else:
                            es.changeteam(user, 1)
                            if swap == 2: es.changeteam(user, swap)
                            elif swap == 3: es.changeteam(user, swap)

                    gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("swap", i, qm_lang("menu action swap", lang = playerlib.getPlayer(i).get("lang"))))
                elif c == 8: gamethread.delayed(.08, _menu.m_intern.i_list.menu("swap", i, qm_lang("menu action swap", lang = playerlib.getPlayer(i).get("lang"))))
                if self._swap.has_key(i): del(self._swap[i])

            def swap(self, i, c, n):
                if c in _menu.m_intern.i_list._list[n]:
                    team = _menu.m_intern.i_list._list[n][c][1]
                    m = popuplib.find("qm_action_swap")


                    if team == 2:
                        self._swap[i] = (_menu.m_intern.i_list._list[n][c][0], 3, 1, _menu.m_intern.i_list._list[n][c][2])
                        m.modline(1, _menu.lang("menu action swap name", f = {"player" : self._swap[i][2]}))

                        m.modline(3, _menu.lang("menu action swap %s3" % qm_game, i = 1))
                        m.modline(4, _menu.lang("menu action swap %s1" % qm_game, i = 2))

                    elif team == 3:
                        self._swap[i] = (_menu.m_intern.i_list._list[n][c][0], 2, 1, _menu.m_intern.i_list._list[n][c][2])
                        m.modline(1, _menu.lang("menu action swap name", f = {"player" : self._swap[i][2]}))
                        m.modline(3, _menu.lang("menu action swap %s2" % qm_game, i = 1))
                        m.modline(4, _menu.lang("menu action swap %s1" % qm_game, i = 2))

                    else:
                        self._swap[i] = (_menu.m_intern.i_list._list[n][c][0], 3, 2, _menu.m_intern.i_list._list[n][c][2])
                        m.modline(1, _menu.lang("menu action swap name", f = {"player" : self._swap[i][2]}))
                        m.modline(3, _menu.lang("menu action swap %s3" % qm_game, i = 1))
                        m.modline(4, _menu.lang("menu action swap %s2" % qm_game, i = 2))

                    m.modline(6, _menu.lang("menu chan", 8, False))
                    m.modline(7, _menu.lang("menu back", 9, False))
                    m.modline(8, _menu.lang("menu exit", 0, False))
                    m.send(i)


        class Slay:
            """
                Action slay
            """

            def slay(self, i, c, n):
                if c in _menu.m_intern.i_list._list[n]:
                    user = _menu.m_intern.i_list._list[n][c][0]
                    if not es.exists("userid", user): es.tell(i, "#multi", qm_lang("userid not exist", opts = {"userid" : _menu.m_intern.i_list._list[n][c][0]}, lang = playerlib.getPlayer(i).get("lang")))
                    else:
                        vecs = es.getplayerlocation(user)
                        es.server.cmd(
                            "es_xgive %s env_explosion;" % user +
                            'es_xfire %s env_explosion addoutput "imagnitude 1";' % user +
                            'es_xfire %s env_explosion addoutput "origin %s %s %s";' % (user, vecs[0], vecs[1], vecs[2]) +
                            "es_xfire %s env_explosion explode;" % user +
                            "es_xsexec %s kill" % user)
                        gamethread.delayed(.08, _menu.m_intern.i_list.menu, (
                            "slay", i,
                            qm_lang("menu action slay", lang = playerlib.getPlayer(i).get("lang")),
                            [u for u in es.getUseridList() if not es.getplayerprop(u, "CBasePlayer.pl.deadflag")]))
                if c == 8: gamethread.delayed(.08, _menu.m_intern.i_list.menu, (
                    "slay", i,
                    qm_lang("menu action slay", lang = playerlib.getPlayer(i).get("lang")),
                    [u for u in es.getUseridList() if not es.getplayerprop(u, "CBasePlayer.pl.deadflag")]))


        class Kick:
            """
                Action kick
            """

            def __init__(self):
                m = popuplib.create("qm_action_kick")
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.submenu(9, "qm_action")
                m.menuselect = self.__kick
                self._kick = {}

            def __kick(self, i, c, n):
                if c == 1 and self._kick.has_key(i):
                    if not es.exists("userid", self._kick[i][0]): es.tell(i, "#multi", qm_lang("userid not exist", opts = {"userid" : self._kick[i][0]}, lang = playerlib.getPlayer(i).get("lang")))
                    else: es.server.queuecmd("kickid %s" % self._kick[i][0])

                    gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("kick", i, qm_lang("menu action kick", lang = playerlib.getPlayer(i).get("lang"))))
                elif c == 8: gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("kick", i, qm_lang("menu action kick", lang = playerlib.getPlayer(i).get("lang"))))
                if self._kick.has_key(i): del(self._kick[i])
                if _menu.m_intern.i_hook._hook.has_key(i): del(_menu.m_intern.i_hook._hook[i])
                _menu.m_intern.i_hook.chat()

            def kick(self, i, c, n):
                if c in _menu.m_intern.i_list._list[n]:
                    self._kick[i] = _menu.m_intern.i_list._list[n][c]
                    _menu.m_intern.i_hook._hook[i] = ("kick", self._kick[i])
                    _menu.m_intern.i_hook.chat()
                    es.tell(i, "#multi", qm_lang("write kick by chat", lang = playerlib.getPlayer(i).get("lang")))

                    m = popuplib.find("qm_action_kick")
                    m.modline(1, _menu.lang("menu action kick name", f = {"player" : self._kick[i][1]}))
                    m.modline(3, _menu.lang("menu action kick now", i = 1))
                    m.modline(5, _menu.lang("menu chan", 8, False))
                    m.modline(6, _menu.lang("menu back", 9, False))
                    m.modline(7, _menu.lang("menu exit", 0, False))
                    m.send(i)


        class Bans:
            """
                Action ban
            """

            def __init__(self):
                m = popuplib.create("qm_action_bans")
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.submenu(9, "qm_action")
                m.menuselect = self.__bans
                self._bans = {}

            def __bans(self, i, c, n):
                if c < 8:
                    _menu._band[self._bans[i][1]] = self._bans[i][2]
                    name = "qm_%s" % self._bans[i][1]
                    _menu.m_intern.i_time.init(name)

                    if c == 1:
                        es.server.queuecmd("banid 1 %s;kickid %s ban 5m" % (self._bans[i][1], self._bans[i][1]))
                        repeat.start(name, 1, 300)
                    elif c == 2:
                        es.server.queuecmd("banid 10 %s;kickid %s ban 10m" % (self._bans[i][1], self._bans[i][1]))
                        repeat.start(name, 1, 600)
                    elif c == 3:
                        es.server.queuecmd("banid 15 %s;kickid %s ban 15m" % (self._bans[i][1], self._bans[i][1]))
                        repeat.start(name, 1, 900)
                    elif c == 4:
                        es.server.queuecmd("banid 30 %s;kickid %s ban 30m" % (self._bans[i][1], self._bans[i][1]))
                        repeat.start(name, 1, 1800)
                    elif c == 5:
                        es.server.queuecmd("banid 60 %s;kickid %s ban 1h" % (self._bans[i][1], self._bans[i][1]))
                        repeat.start(name, 1, 3600)
                    elif c == 6:
                        es.server.queuecmd("banid 120 %s;kickid %s ban 2h" % (self._bans[i][1], self._bans[i][1]))
                        repeat.start(name, 1, 7200)
                    elif c == 7:
                        es.server.queuecmd("banid 0 %s;kickid %s ban permanent" % (self._bans[i][1], self._bans[i][1]))
                        repeat.delete(name)

                    gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("bans", i, qm_lang("menu action ban", lang = playerlib.getPlayer(i).get("lang"))))
                elif c == 8: gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("bans", i, qm_lang("menu action ban", lang = playerlib.getPlayer(i).get("lang"))))
                if self._bans.has_key(i): del(self._bans[i])
                if _menu.m_intern.i_hook._hook.has_key(i): del(_menu.m_intern.i_hook._hook[i])
                _menu.m_intern.i_hook.chat()

            def bans(self, i, c, n):
                if c in _menu.m_intern.i_list._list[n]:
                    self._bans[i] = _menu.m_intern.i_list._list[n][c]
                    _menu.m_intern.i_hook._hook[i] = ("bans", self._bans[i])
                    _menu.m_intern.i_hook.chat()
                    es.tell(i, "#multi", qm_lang("write ban by chat", lang = playerlib.getPlayer(i).get("lang")))

                    m = popuplib.find("qm_action_bans")
                    m.modline(1, _menu.lang("menu action ban name", f = {"player" : self._bans[i][2]}))
                    m.modline(3, _menu.lang("menu action ban 5", i = 1))
                    m.modline(4, _menu.lang("menu action ban 10", i = 2))
                    m.modline(5, _menu.lang("menu action ban 15", i = 3))
                    m.modline(6, _menu.lang("menu action ban 30", i = 4))
                    m.modline(7, _menu.lang("menu action ban 60", i = 5))
                    m.modline(8, _menu.lang("menu action ban 120", i = 6))
                    m.modline(9, _menu.lang("menu action ban perm", i = 7))
                    m.modline(11, _menu.lang("menu chan", 8, False))
                    m.modline(12, _menu.lang("menu back", 9, False))
                    m.modline(13, _menu.lang("menu exit", 0, False))
                    m.send(i)


        class Remo:
            """
                Action unban
            """

            def __init__(self):
                m = popuplib.create("qm_action_remo")
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.addline(qm_lang["menu spac"])
                m.submenu(9, "qm_action")
                m.menuselect = self.__remo
                self._remo = {}

            def __remo(self, i, c, n):
                if c == 1:
                    if not es.exists("userid", self._remo[i][0]): es.tell(i, "#multi", qm_lang("userid not exist", opts = {"userid" : self._remo[i][0]}, lang = playerlib.getPlayer(i).get("lang")))
                    else:
                        es.server.queuecmd("removeid %s;writeid" % self._remo[i][1])
                        gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("remo", i, qm_lang("menu action unban", lang = playerlib.getPlayer(i).get("lang"))))
                elif c == 8: gamethread.delayed(.08, _menu.m_intern.i_list.menu, ("remo", i, qm_lang("menu action unban", lang = playerlib.getPlayer(i).get("lang"))))
                if self._remo[i][1] in _menu._band: del(_menu._band[self._remo[i][1]])
                if self._remo.has_key(i): del(self._remo[i])
                if _menu.m_intern.i_hook._hook.has_key(i): del(_menu.m_intern.i_hook._hook[i])
                _menu.m_intern.i_hook.chat()

            def remo(self, i, c, n):
                if c in _menu.m_intern.i_list._list[n]:
                    self._remo[i] = _menu.m_intern.i_list._list[n][c]
                    _menu.m_intern.i_hook._hook[i] = ("remo", self._remo[i])
                    _menu.m_intern.i_hook.chat()

                    m = popuplib.find("qm_action_remo")
                    m.modline(1, _menu.lang("menu action unban name", f = {"player" : self._remo[i][2]}))
                    m.modline(3, _menu.lang("menu action unban now", i = 1))
                    m.modline(5, _menu.lang("menu chan", 8, False))
                    m.modline(6, _menu.lang("menu back", 9, False))
                    m.modline(7, _menu.lang("menu exit", 0, False))
                    m.send(i)



    class Levels:
        """
            change maps
        """

        def maps(self, i, c, n):
            if c in _menu.m_intern.i_list._list[n]:
                mode = _menu._maps[i]
                name = _menu.m_intern.i_list._list[n][c]
                popuplib.send(n, i)

                if not es.exists("map", name): es.tell(i, "#multi", qm_lang("map not exist", opts = {"mapname" : name}, lang = playerlib.getPlayer(i).get("lang")))
                if mode == 1:
                    es.forcevalue("eventscripts_nextmapoverride", "")
                    gamethread.delayed(2, es.server.queuecmd, "changelevel %s" % name)
                    for user in es.getUseridList():
                        es.tell(user, "#multi", qm_lang("change level", opts = {"newmap" : name}, lang = playerlib.getPlayer(user).get("lang")))

                elif mode == 2:
                    es.forcevalue("eventscripts_nextmapoverride", "")
                    es.forcevalue("nextlevel", name)
                    for user in es.getUseridList():
                        es.tell(user, "#multi", qm_lang("change level after round", opts = {"newmap" : name}, lang = playerlib.getPlayer(user).get("lang")))

                elif mode == 3:
                    es.forcevalue("nextlevel", "")
                    es.forcevalue("eventscripts_nextmapoverride", name)
                    for user in es.getUseridList():
                        es.tell(user, "#multi", qm_lang("change level after time", opts = {"newmap" : name}, lang = playerlib.getPlayer(user).get("lang")))



    class Execmd:
        """
            Execute a server command
        """

        def cmnd(self, i, c, n):
            if c in _menu.m_intern.i_list._list[n]:
                es.server.queuecmd(_menu.m_intern.i_list._list[n][c][1])
                popuplib.send(n, i)
            elif _menu.m_intern.i_hook._hook.has_key(i): del(_menu.m_intern.i_hook._hook[i])
            _menu.m_intern.i_hook.chat()



    class Restri:
        """
            Execute a server command
        """

        def rest(self, i, c, n):
            if c in _menu.m_intern.i_list._list[n]:
                name = _menu.m_intern.i_list._list[n][c][0]
                rest = _menu.m_intern.i_list._list[n][c][1]
                m = popuplib.find(n)

                global qm_arms
                if qm_game == "css": indx = qm_arms[name][0]
                elif qm_game == "dod": indx = qm_arms[name]

                if not indx:
                    if qm_game == "css": qm_arms[name][0] += 1
                    elif qm_game == "dod": qm_arms[name] += 1
                    m.modline(c + 2, "->%s. * %s" % (c, rest))
                    for user in es.getUseridList():
                        es.tell(user, "#multi", qm_lang("weapon resctricted", opts = {"weapon" : rest}, lang = playerlib.getPlayer(user).get("lang")))

                else:
                    if qm_game == "css": qm_arms[name][0] = 0
                    elif qm_game == "dod": qm_arms[name] = 0
                    m.modline(c + 2, "->%s. %s" % (c, rest))
                    for user in es.getUseridList():
                        es.tell(user, "#multi", qm_lang("weapon unresctricted", opts = {"weapon" : rest}, lang = playerlib.getPlayer(user).get("lang")))
                m.send(i)

        def remo(self, i, w = ""):
            if qm_game == "css" and qm_arms.has_key(w):
                if qm_arms[w][0]:
                    if w in qm_cate[6][1]:
                        if w == "vest": es.setplayerprop(i, "CCSPlayer.m_ArmorValue", 0)
                        elif w == "vesthelm":
                            es.setplayerprop(i, "CCSPlayer.m_bHasHelmet", 0)
                            es.setplayerprop(i, "CCSPlayer.m_ArmorValue", 0)
                        elif w == "defuser": es.setplayerprop(i, "CCSPlayer.m_bHasDefuser", 0)
                        elif w == "nvgs": es.setplayerprop(i, "CCSPlayer.m_bHasNightVision", 0)
                        else: es.server.queuecmd(
                            "es_xsexec %s use weapon_knife;" % i +
                            "es_xfire %s weapon_%s kill" % (i, w))

                    else:
                        es.server.queuecmd(
                        "es_xsexec %s use weapon_knife;" % i +
                        "es_xfire %s weapon_%s kill" % (i, w))

                    cash = es.getplayerprop(i, "CCSPlayer.m_iAccount") + qm_arms[w][1]
                    if cash > 16000: cash = 16000
                    es.setplayerprop(i, "CCSPlayer.m_iAccount", cash)
                    es.tell(i, "#multi", qm_lang("weapon user removed", opts = {
                        "weapon" : qm_lang("menu restri %s" % w, lang = playerlib.getPlayer(i).get("lang"))},
                                                 lang = playerlib.getPlayer(i).get("lang")))

            elif qm_game == "dod":
                for weap in qm_arms:
                    if qm_arms[weap]:
                        for indx in es.createentitylist("weapon_%s" % weap):
                            if es.getplayerhandle(i) == es.getindexprop(indx, "CBaseCombatWeapon.m_hOwner"):
                                es.server.queuecmd("es_xfire %s weapon_%s kill" % (i, weap))
                                es.tell(i, "#multi", qm_lang("weapon user removed", opts = {
                                    "weapon" : qm_lang("menu restri %s" % weap, lang = playerlib.getPlayer(i).get("lang"))},
                                                             lang = playerlib.getPlayer(i).get("lang")))








def init():
    global _menu, _maps, _user, _cmnd
    _menu, _maps = Menu(), [os.path.splitext(n)[0] for n in os.listdir("%s/maps/" % qm_path) if os.path.splitext(n)[1] == ".bsp"]

    f = File()
    _user = f.read("%s/cfg/quick_menu/adminlist.cfg" % qm_path)
    _cmnd = f.read("%s/cfg/quick_menu/command.cfg" % qm_path, "=")

    if not len(_user): es.dbgmsg(0, "[quick_menu] Can't load admin list")
    else: es.dbgmsg(0, "[quick_menu] Has been loaded successfully")

def player_cmd():
    user = es.getcmduserid()
    if es.getplayersteamid(user) in _user:
        name = popuplib.active(user)["name"]
        if name != "0": popuplib.find(name).update(user)
        else: popuplib.send("qm_recept", user)

def load():
    es.regsaycmd("!qm", "quick_menu/player_cmd", "command for acces quick menu")
    es.regclientcmd("!qm", "quick_menu/player_cmd", "command for acces quick menu")
    init()

def unload():
    es.unregsaycmd("!qm")
    es.unregclientcmd("!qm")
    _menu.m_intern.i_hook.stop()
    for menu in _menu._name: popuplib.delete(menu)
    for time in _menu._band: repeat.delete("qm_%s" % time)
    es.dbgmsg(0, "[quick_menu] Has been unloaded successfully")

def es_map_start(e):
    for time in _menu._band: repeat.delete("qm_%s" % time)
    for menu in _menu._name: popuplib.delete(menu)
    _menu.m_intern.i_hook.stop()
    init()

def player_disconnect(e):
    if e["networkid"] in _user:
        user = int(e["userid"])
        if _menu.m_intern.i_hook._hook.has_key(user):
            del(_menu.m_intern.i_hook._hook[user])
            _menu.m_intern.i_hook.chat()

def player_spawn(e):
    _menu.m_restri.remo(e["userid"])

def item_pickup(e):
    _menu.m_restri.remo(e["userid"], e["item"])
